! Leonardo Marques, 06/89041
! Programacao para Sistemas Fisicos - Turma A

! Ambiente de desenvolvimento:
! Compilador: ifort 11.0
! Sistema Operacional: Ubuntu GNU/Linux 8.10

! Problema:
! Calcula o cross product de dois vetores
! dados

PROGRAM crossproduct; ! Começo do Programa

        ! Variaveis
        IMPLICIT NONE;
        ! Define arquivo de entrada
        CHARACTER(Len=*), PARAMETER :: input_file = './input_crossproduct.txt';
        ! Define arquivo de saída
        CHARACTER(Len=*), PARAMETER :: output_file = './output_crossproduct.txt';
        INTEGER :: estado; ! Armazena o estado da leitura
        INTEGER :: counter; ! Contador
        REAL, DIMENSION(2,3) :: vetores; ! Armazena os vetores de entrada
        REAL, DIMENSION(3) :: crossab; ! Recebe o resultado do produto vetorial 

        ! Dados do programador 
        PRINT *, 'Leonardo Marques, 06/89041';
        PRINT *, 'Engenharia Elétrica, 5º semestre';
        PRINT *, 'Data de hoje 4/11/09'; 
        PRINT *, 'Programa crossproduct.'; PRINT *, '';
       
        ! Entrada dos dados 
        PRINT *, '* Lendo o arquivo de entrada: ', input_file;
        CALL leitura(input_file); ! Abre o arquivo pra leitura 
        DO counter = 1, 2, 1
                ! Le o arquivo de entrada e salva os valores na matriz vetores
                READ(UNIT=100, FMT=*, IOSTAT=estado) vetores(counter,1),&
                & vetores(counter,2), vetores(counter,3);
                ! Checagem dos dados 
                IF (estado /= 0 .AND. estado /= -1) STOP 'Erro de leitura: entrada inválida';
        END DO;

        ! Processamento dos dados
        CALL crossprod(vetores,crossab); ! Calcula o produto cruzado
        
        ! Impressao dos resultados
        PRINT *, '* Impressao dos dados no arquivo: ', output_file; 
        CALL escrita(output_file); ! Abre o arquivo pra escrita
        ! Escreve o resultado no arquivo de saída
        WRITE(UNIT=101, FMT=*) crossab(1),'i',crossab(2),'j', crossab(3),'k'; 

END PROGRAM crossproduct; ! Fim do programa
