! Leonardo Marques, 06/89041
! Programacao para Sistemas Fisicos - Turma A

! Ambiente de desenvolvimento:
! Compilador: ifort 11.0
! Sistema Operacional: Ubuntu GNU/Linux 8.10

! Problema:
! Calcula o produto matricial, matrizxvetor

PROGRAM mproduct3; ! Começo do Programa

        ! Variaveis
        IMPLICIT NONE;
        CHARACTER(Len=*), PARAMETER :: input1 = './matrix3.txt'
        CHARACTER(Len=*), PARAMETER :: output1 = './output_mproduct.txt'
        INTEGER :: unidade1 = 100;
        INTEGER :: unidade2 = 101;
        REAL, DIMENSION(:,:), ALLOCATABLE :: matrixA;
        REAL, DIMENSION(:), ALLOCATABLE :: matrixB;
        REAL, DIMENSION(:), ALLOCATABLE :: matrixC;
        INTEGER :: estado;
        INTEGER :: dimensao;
        INTEGER :: linhas, colunas;


        !Dados do programador 
        PRINT *, 'Leonardo Marques, 06/89041';
        PRINT *, 'Engenharia Elétrica, 5º semestre';
        PRINT *, 'Data de hoje 11/11/09'; 
        PRINT *, 'Programa mproduct3.'; PRINT *, '';
        
        ! Entrada dos dados
        CALL leitura(input1, unidade1);
        READ(UNIT=unidade1, FMT=*, IOSTAT=estado) dimensao; ! Recebe dimensao
        IF (estado /= -1 .AND. estado /= 0) STOP 'erro de leitura'; ! Checagem da dimensao
        
        ! Aloca as matrizes de acordo com a dimensao lida
        ALLOCATE(matrixA(dimensao,dimensao));
        ALLOCATE(matrixB(dimensao));
        
        ! Le matrixA e matrixB
        DO linhas = 1, dimensao, 1;    
                IF (estado == -1) EXIT;
                IF (estado /= -1 .AND. estado /= 0) STOP 'erro de leitura';
                READ(UNIT=unidade1, FMT=*, IOSTAT=estado) (matrixA(linhas,colunas), colunas=1, dimensao), matrixB(linhas);
        END DO;
      
        ! Processamento 
        ALLOCATE(matrixC(dimensao));
        ! Chama rotina de calculo matricial
        CALL matrixproduct(matrixA,matrixB,dimensao,matrixC);
        
        ! Saida dos dados
        CALL escrita(output1, unidade2); ! Chama rotina de escrita dos dados
        ! Escreve matrixA
        WRITE(UNIT=unidade2, FMT=*) '* Matriz A lida de ', input1;
        DO linhas = 1, dimensao, 1;
                WRITE(UNIT=unidade2, FMT=*) (matrixA(linhas,colunas), colunas=1, dimensao);
        END DO;

        !Escreve matrixB
        WRITE(UNIT=unidade2, FMT=*) '* Matriz B lida de ', input1;
        DO linhas = 1, dimensao, 1;
                WRITE(UNIT=unidade2, FMT=*) matrixB(linhas); 
        END DO;

        ! Escreve matrixC
        WRITE(UNIT=unidade2, FMT=*) '* Matriz C = A X B';
        DO linhas = 1, dimensao, 1;
               WRITE(UNIT=unidade2, FMT=*) matrixC(linhas); 
        END DO;
       
        PRINT*, '- Resultado do processamento em ', output1; 
         
END PROGRAM mproduct3; ! Fim do programa
