! Leonardo Marques, 06/89041
! Programacao para Sistemas Fisicos - Turma A

! Ambiente de desenvolvimento:
! Compilador: ifort 11.0
! Sistema Operacional: Ubuntu GNU/Linux 8.10

! Problema:
! Para dada uma massa e um raio de um planeta 
! calcula a velocidade de escape.


PROGRAM escape2; ! Começo do Programa

        ! Variaveis
        IMPLICIT NONE;
        REAL, PARAMETER :: G = 6.67428E-11; ! constante gravitacional em m^3/kg*s^2
        REAL :: raio; ! Raio médio do planeta em metros
        REAL :: massa; ! massa do planeta em kg
        REAL :: veloc_escape; ! Velocidade de escape em m/s

        ! Dados do programador 
        PRINT *, 'Leonardo Marques, 06/89041';
        PRINT *, 'Engenharia Elétrica, 5º semestre';
        PRINT *, 'Data de hoje 23/08/09'; 
        PRINT *, 'Programa escape2.'; PRINT *, '';

        ! Receber e armazenar dados
        PRINT*, 'Entre com o raio do planeta em metros, formato: numeroEexpoente';
        READ*, raio;
        PRINT*, 'Entre com a massa do planeta em kg, formato: numeroEexpoente';
        READ*, massa;

        ! Processamento
        veloc_escape = sqrt(2*G*massa/raio); ! Calcula velocidade de escape        

        ! Imprimir dados recebidos e resultados
        PRINT*, 'Raio do planeta: ', raio, 'm';
        PRINT*, 'Massa do planeta: ', massa, 'kg';
        PRINT*, 'Constante gravitacional: ', G, 'm^3/kg*s';
        PRINT*, 'A velocidade de escape para esse planeta é: ', veloc_escape, 'm/s';

END PROGRAM escape2; ! Fim do programa
