! Leonardo Marques, 06/89041
! Programacao para Sistemas Fisicos - Turma A

! Ambiente de desenvolvimento:
! Compilador: ifort 11.0
! Sistema Operacional: Ubuntu GNU/Linux 8.10

! Problema:
! Para dada uma massa e um raio de um planeta 
! calcula a velocidade de escape.


PROGRAM escape; ! Começo do Programa

        ! Variaveis
        IMPLICIT NONE;
        REAL, PARAMETER :: g_mantissa = 6.67428, g_expoente = -11; ! constante gravitacional em m^3/kg*s^2
        REAL :: r_mantissa, r_expoente; ! Raio médio do planeta em metros
        REAL :: m_mantissa, m_expoente; ! massa em kg
        REAL :: veloc_escape; ! Velocidade de escape em km/s

        ! Dados do programador 
        PRINT *, 'Leonardo Marques, 06/89041';
        PRINT *, 'Engenharia Elétrica, 5º semestre';
        PRINT *, 'Data de hoje 23/08/09'; 
        PRINT *, 'Programa escape.'; PRINT *, '';

        ! Receber e armazenar dados
        PRINT*, 'Entre com o raio do planeta em metros, formato: mantissa expoente';
        READ*, r_mantissa, r_expoente;
        PRINT*, 'Entre com a massa do planeta em kg, formato: mantissa expoente';
        READ*, m_mantissa, m_expoente;

        ! Processamento
        veloc_escape = sqrt(2*g_mantissa*m_mantissa/r_mantissa)*sqrt(10**(g_expoente+m_expoente-r_expoente));        

        ! Imprimir dados recebidos e resultados
        PRINT*, 'Raio do planeta: ', r_mantissa*10**r_expoente, 'm';
        PRINT*, 'Massa do planeta: ', m_mantissa*10**m_expoente, 'kg';
        PRINT*, 'Constante gravitacional: ', g_mantissa*10**g_expoente, 'm^3/kg*s';
        PRINT*, 'A velocidade de escape para esse planeta é: ', veloc_escape, 'm/s';

END PROGRAM escape; ! Fim do programa
