! Leonardo Marques, 06/89041
! Programacao para Sistemas Fisicos - Turma A

! Ambiente de desenvolvimento:
! Compilador: gfortran 
! Sistema Operacional: Ubuntu GNU/Linux 8.10

! Problema: Dado uma lista de números, encontrar
! o maior, o menor e suas respectivas posicoes


PROGRAM exercicio7v2; ! Começo do Programa

        ! Variaveis
        IMPLICIT NONE;
        REAL, POINTER :: storage(:,:);
        REAL, DIMENSION(4) :: vetor;
        INTEGER :: estado; ! verifica se não tem erro de entrada
        INTEGER :: counter, i; ! Conta quantas linhas o arquivo de entrada possui
        CHARACTER(Len=*), PARAMETER :: error1 = 'Problema na leitura do arquivo&
        & de entrada'; ! Mensagem de erro caso o arquivo de entrada não esteja OK
        ! Define arquivo de entrada
        CHARACTER(Len=*), PARAMETER :: input_file = './input_exercicio7.txt'; 
        ! Define arquivo de saída
        CHARACTER(Len=*), PARAMETER :: output_file = './output_exercicio7.txt';
        
        ! Dados do programador 
        PRINT *, 'Leonardo Marques, 06/89041';
        PRINT *, 'Engenharia Elétrica, 5º semestre';
        PRINT *, 'Data de hoje 30/10/09'; 
        PRINT *, 'Programa exercicio7v2.'; PRINT *, '';

        ! Receber e armazenar dados
        !CALL escrita; ! Abre o arquivo de saída para escrita
        ALLOCATE(storage(10,2));        
         
!        WRITE(UNIT=101, FMT=*) 'POSICAO ', 'VALOR';
        
        ! Valores iniciais para counter, menor e maior'
        counter = 1;
        DO 
                CALL leitura; ! Abre o arquivo para leitura
                ! Le o arquivo, caso encontre o EOF, vai para o label 88
                ALLOCATE(storage(counter,2));        
                READ(UNIT=100, FMT=*, IOSTAT=estado, END=88) storage(counter,1), storage(counter,2);
                IF (estado /= 0) STOP error1; ! Checagem da leitura ok do arquivo
                counter = counter+1; !Contando o número de elementos
        END DO;
        
        ! Imprimir dados recebidos e resultados
88      DO i =1, counter, 1;
                PRINT*, 'i = ', i, 'Posicao:', storage(i,1), 'Valor:', storage(i,2);
        END DO;
        

        !WRITE(UNIT=101, FMT=*) '% O maior valor é ', vetor(3), 'na posicao ',&
        !&vetor(4);
        !WRITE(UNIT=101, FMT=*) '% O menor valor é ', vetor(1), 'na posicao ',&
        !&vetor(2);
        !WRITE(UNIT=101, FMT=*) '% Total de numeros lidos', counter;

        PRINT *, 'Resultados impressos em ', output_file;


        !Funções
        CONTAINS
        SUBROUTINE leitura; ! Abrir arquivo para leitura 
                OPEN(UNIT=100, FILE=input_file, STATUS='UNKNOWN', ACCESS='SEQUENTIAL', &
                & ACTION='READ');
        END SUBROUTINE leitura; ! Fim abrir arquivo para leitura

        SUBROUTINE escrita; ! Abrir arquivo para escrita
                OPEN(UNIT=101, FILE=output_file, STATUS='UNKNOWN', ACCESS='SEQUENTIAL', &
                & ACTION='WRITE');
        END SUBROUTINE escrita; ! Fim abrir arquivo para escrita
       
END PROGRAM exercicio7v2; ! Fim do programa
